package io.zipcoder.interfaces;

public enum Educator implements Teacher {

    KRIS(100, "Kris Younger"),
    NHU(101, "Nhu Nguyen"),
    LEON(102, "Leon Hunter"),
    DOLIO(103, "Dolio Durant"),
    WILHEM(104, "Wilhem Alcivar"),
    FROILAN(105, "Froilan Miranda");

    private double timeWorked;
    private long id;
    private String name;
    private final Instructor instructor;

    Educator(long id, String name) {
        this.id = id;
        this.name = name;
        this.timeWorked = 0;
        this.instructor = new Instructor(id, name);
        Instructors instructors = Instructors.getInstance();
        instructors.add(this.instructor);
    }

    public void teach(Learner learner, double numberOfHours) {

        learner.learn(numberOfHours);
        timeWorked += numberOfHours;

    }

    public void lecture(Learner[] learners, double numberOfHours) {

        for (Learner l : learners) {
            teach(l, numberOfHours/learners.length);
        }
    }
}
