package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestInstructor {

    Instructor instructor = new Instructor(5, "Sue");
    Student student = new Student(1, "Bob");
    Student student2 = new Student(2, "Joe");
    Student student3 = new Student(3, "Larry");
    Student student4 = new Student(4, "Morgan");
    Learner[] learners = {student, student2, student3, student4};

    @Test
    public void testImplementation() {
        //Given
        boolean expected = true;

        //When
        boolean actual = instructor instanceof Teacher;

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testInheritance() {
        //Given
        boolean expected = true;

        //When
        boolean actual = instructor instanceof Person;

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testTeach() {
        //Given
        double before = student.getTotalStudyTime();
        double numberOfHours = 5.0;
        double expected = before + numberOfHours;

        //When
        instructor.teach(student, numberOfHours);
        double actual = student.getTotalStudyTime();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testLecture() {
        //Given
        double before = student.getTotalStudyTime();
        double numberOfHours = 20.0;
        double expected = before + (numberOfHours / learners.length);

        //When
        instructor.lecture(learners, numberOfHours);
        double actual = student.getTotalStudyTime();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }
}
