package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class TestPeople {

    Instructors instructors = Instructors.getInstance();
    Students students2 = Students.getInstance();
    Student s1 = new Student(51, "Ned Redmond");
    Student s2 =new Student(52, "Seth Abrams");
    Student s3 = new Student(53, "Akeem Cherry");

    @Test
    public void testAdd() {
        //Given
        int before = students2.getCount();
        int expected = before + 3;

        //When
        students2.add(s1);
        students2.add(s2);
        students2.add(s3);
        int actual = students2.getCount();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testRemoveByPerson() {
        //Given
        int before = students2.getCount();
        int expected = before + 2;

        //When
        students2.add(s1);
        students2.add(s2);
        students2.add(s3);
        students2.remove(s2);
        int actual = students2.getCount();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testRemoveById() {
        //Given
        int before = students2.getCount();
        int expected = before + 2;

        //When
        students2.add(s1);
        students2.add(s2);
        students2.add(s3);
        students2.remove(52);
        int actual = students2.getCount();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testFindById() {
        //Given
        Person expected = s2;

        //When
        students2.add(s1);
        students2.add(s2);
        students2.add(s3);
        Student actual = students2.findById(52);

        //Then
        Assert.assertEquals(expected, actual);
    }


}
